<?php

class PrivateMessagePage extends Page {
	function requireDefaultRecords() {
		if(!DataObject::get("PrivateMessagePage")) {
			$page = new PrivateMessagePage();
			$page->Title = "Private Messages";
			$page->write();
			$page->doPublish();
		}
	}	
}

class PrivateMessagePage_Controller extends Page_Controller {
	function init() {
		if(!Member::currentUserID()) Security::permissionFailure();
		parent::init();
	}
	//returns all messages submitted to the logged in user.
	function MyMessages() {
		return DataObject::get("PrivateMessage", "ToID = " . Member::currentUserID(), "Created DESC");
	}

	function PostMessageForm() {            
                //Nicknames of all members is passed into an array
		$members = DataObject::get("Member", "", "Nickname");
		$allMembers = array();
		foreach($members as $member) {
                    //Only Members of the forum-members group should appear in the $allMembers array
                    if($member->inGroup("forum-members")){
                        $allMembers[$member->ID] = htmlentities($member->Nickname);
                    }
		}
		$me = Member::currentUser();
		return new Form($this, "PostMessageForm", new FieldSet(
			new ReadonlyField("From", _t('PrivateMessagePage.FROM', 'From'), "$me->Nickname"),
			new DropdownField("ToID", _t('PrivateMessagePage.CHOOSERECEIVER', 'Choose receiver:'), $allMembers),
			new TextField("Subject", _t('PrivateMessagePage.SUBJECT', 'Subject')),
			new TextareaField("Body", _t('PrivateMessagePage.TEXT', 'Text'))
            
            ),
            new FieldSet(
                new FormAction("doPostMessage", _t('PrivateMessagePage.SUBMIT', 'submit'))
            ),
            //Required fields are named inside the array. Without subject messages can´t be red.
            new RequiredFields(array('Subject', 'Body'))
        );
	}
    //A form that is appended when a single message is red.
    function ReplyMessageForm() {
		$me = Member::currentUser();
        //The Parameters from the sent message are loaded into $message
        $message = DataObject::get_by_id("PrivateMessage", $this->urlParams['ID']);
        //Get the senders data
        $sender = DataObject::get_by_id("Member", $message->FromID);
		return new Form($this, "PostMessageForm", new FieldSet(
			new HiddenField("ToID", _t('PrivateMessagePage.RECEIVER', 'receiver'), "$message->FromID"),
			new TextField("Subject", _t('PrivateMessagePage.SUBJECT', 'Subject'), "Re: $message->Subject"),
			new TextareaField("Body", "Text", 20, 20, "

$sender->Nickname: $message->Body")
                        //new ReadonlyField("Urspr&uuml;ngliche Nachricht", null, "$message->Body")
            ),
            new FieldSet(
                new FormAction("doPostMessage", _t('PrivateMessagePage.SUBMIT', 'submit'))
            ),
            //Required fields are named inside the array. Without subject messages couldn´t be read.
            new RequiredFields(array('Subject', 'Body'))
        );
	}
	//Save the input to the database
	function doPostMessage($data, $form) {
		$message = new PrivateMessage();
		$form->saveInto($message);
		$message->FromID = Member::currentUserID();
		$message->write();
		
		Director::redirect($this->Link());
	}
	//read the content of a single message. The ID of the message is passed via URL.
	function message() {
		$message = DataObject::get_by_id("PrivateMessage", $this->urlParams['ID']);
        //The message is only passed if the reader ist the receiver. Otherwise any message could be read by altering the id.
		if($message->ToID == Member::currentUserID()) {
            //message gets marked as read
            $message->read = true;
            $message->write();
			return array(
				'CurrentMessage' => $message			
			);
		} else {
			return array();
		}
	}
    //Deleting a single message
    function delete() {
        $message = DataObject::get_by_id("PrivateMessage", $this->urlParams['ID']);
        if($message){
            $message->delete();
            Director::redirect($this->Link());
        }
    }
	

}